VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsShaft"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Public Closed As Boolean
Public ID As Integer
Private Levels() As Boolean
Public CommandAfterClose As String
Public nTarget As Integer
Public nOldTarget As Integer
Public fHasTarget As Boolean
Public fMovingUp As Boolean

Public dClosingTime As Double
Public fToBeClosed As Boolean

Public Function IsAvailable() As Boolean
Dim c As Integer
IsAvailable = True
For c = 0 To nLevels - 1
    If Levels(c) = True Then IsAvailable = False
Next c
End Function

Private Sub Class_Initialize()
ReDim Levels(nLevels)
End Sub

Public Sub CloseDoor()
    Send "close " & ID & vbCrLf
End Sub

Public Sub GoToTarget()
    If fHasTarget Then
        Send "floor " & ID & " " & nTarget & vbCrLf
        Send "shaftinfo " & ID & " " & nTarget & vbCrLf
    End If
End Sub

Public Sub OpenDoor()
    Send "open " & ID & vbCrLf
End Sub





Public Sub GetNextTarget()
    Dim c As Integer
    Dim nFinish As Integer
    
    If fMovingUp Then nFinish = nLevels Else nFinish = 0
    
    nOldTarget = nTarget
'    For c = 0 To nLevels - 1
    If Not nFinish = nOldTarget Then
    For c = nOldTarget To nFinish Step Sgn(nFinish - nOldTarget)
        If Levels(c) Then
                If Not c = nOldTarget Then
                For d = nOldTarget To c - Sgn(c - nOldTarget) Step Sgn(c - nOldTarget)
                    If c > nOldTarget Then
                        If Floors(d).fButtonUp Then
                            nTarget = d
                            fHasTarget = True
                            SetDirectionFlags
                            Exit Sub
                        End If
                    Else
                        If Floors(d).fButtonDown Then
                            nTarget = d
                            fHasTarget = True
                            SetDirectionFlags
                            Exit Sub
                        End If
                    End If
                Next d
                End If
            
        
            nTarget = c
            fHasTarget = True
            SetDirectionFlags
            Exit Sub
        End If
    Next
    End If
    
    fMovingUp = Not fMovingUp
    If fMovingUp Then nFinish = nLevels Else nFinish = 0
    
    If Not nFinish = nOldTarget Then
    For c = nOldTarget To nFinish Step Sgn(nFinish - nOldTarget)
        If Levels(c) Then
            If Not c = nOldTarget Then
                For d = nOldTarget To c - Sgn(c - nOldTarget) Step Sgn(c - nOldTarget)
                    If c > nOldTarget Then
                        If Floors(d).fButtonUp Then
                            nTarget = d
                            fHasTarget = True
                            SetDirectionFlags
                            Exit Sub
                        End If
                    Else
                        If Floors(d).fButtonDown Then
                            nTarget = d
                            fHasTarget = True
                            SetDirectionFlags
                            Exit Sub
                        End If
                    End If
                Next d
            End If
            
        
            nTarget = c
            fHasTarget = True
            SetDirectionFlags
            Exit Sub
        End If
    Next
    End If
    
    For c = 0 To nLevels - 1
        If Floors(c).fButtonDown Then
            nTarget = c
            fHasTarget = True
            fMovingUp = False
            SetDirectionFlags
            Exit Sub
        End If
        If Floors(c).fButtonUp Then
            nTarget = c
            fHasTarget = True
            fMovingUp = True
            SetDirectionFlags
            Exit Sub
        End If
    Next
    fHasTarget = False
End Sub

Private Sub SetDirectionFlags()
If nTarget > nOldTarget Then
    fMovingUp = True
Else
    fmovingdown = False
End If
End Sub

Public Sub SetFloor(nLevel As Integer, nSetting As Boolean)
    Levels(nLevel) = nSetting
End Sub
